"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.repeat = repeat;
var _encoder = require("../encoder/encoder");
var _nodes = require("../utils/nodes");
function repeat(options, nodes) {
  const children = (0, _nodes.asNodeArray)(nodes);
  if (children.length === 0) {
    throw new Error('`repeat` should receive at least one element');
  }
  return {
    type: 'repeat',
    children,
    options,
    encode: encodeRepeat
  };
}
function encodeRepeat() {
  var _this$options;
  const atomicNodes = (0, _encoder.encodeAtom)(this.children);
  if ('count' in this.options) {
    return {
      precedence: 'sequence',
      pattern: `${atomicNodes.pattern}{${this.options.count}}`
    };
  }
  return {
    precedence: 'sequence',
    pattern: `${atomicNodes.pattern}{${this.options.min},${((_this$options = this.options) === null || _this$options === void 0 ? void 0 : _this$options.max) ?? ''}}`
  };
}
//# sourceMappingURL=repeat.js.map