import { encodeAtom } from '../encoder/encoder';
import { asNodeArray } from '../utils/nodes';
export function oneOrMore(nodes) {
  return {
    type: 'oneOrMore',
    children: asNodeArray(nodes),
    encode: encodeOneOrMore
  };
}
export function optionally(nodes) {
  return {
    type: 'optionally',
    children: asNodeArray(nodes),
    encode: encodeOptionally
  };
}
export function zeroOrMore(nodes) {
  return {
    type: 'zeroOrMore',
    children: asNodeArray(nodes),
    encode: encodeZeroOrMore
  };
}
function encodeOneOrMore() {
  return {
    precedence: 'sequence',
    pattern: `${encodeAtom(this.children).pattern}+`
  };
}
function encodeOptionally() {
  return {
    precedence: 'sequence',
    pattern: `${encodeAtom(this.children).pattern}?`
  };
}
function encodeZeroOrMore() {
  return {
    precedence: 'sequence',
    pattern: `${encodeAtom(this.children).pattern}*`
  };
}
//# sourceMappingURL=quantifiers.js.map